#include "GV.h"

#define DATA_MAX 65536

#define FIELD_MAX_X 15
#define FIELD_MAX_Y 15

#define CHIP_NUM 62//`bv̎

struct{
	//}bvf[^
	int data[DATA_MAX];
	int temp_data[DATA_MAX];//map_max_xύXꂽ̈ꎞۑ
	//}bv̍ő
	int map_max_x;
	int map_max_y;
	//}bvԍ
	int map_num;
	//\̈̍̍W
	int field_x;
	int field_y;
	//J[\̈ʒu
	int cursor_x;
	int cursor_y;
	//IĂꏊ̔ԍ(}bv̊OIł-1)
	int select_data_num;
	//IĂ`bv(f[^̒g)
	int select_chip_num;
	//}EXgp邩
	int mouse_use_flag;
	//`bv摜ŕ\邩
	int graph_chip_mode;
	//`bv̉摜
	int img_chip[CHIP_NUM];
	//Obh̐F
	int grid_color;
	int grid_color2;
	//̐F
	int char_color;
	//J[\̐F
	int cursor_color;
	//{^̐F
	int button_color;
	//bZ[W
	char message_text[128];
	char message_count;
}editor;

void editor_ini();
void editor_map_select();
void editor_map_size_control();
void editor_move();
void editor_chip_select();
void editor_save();
void editor_load();
void editor_main();
void editor_graph();

void editor_ini(){
	char fname[64];
	editor.map_max_x=30;
	editor.map_max_y=30;
	editor.mouse_use_flag=1;
	editor.grid_color=GetColor(255,255,255);
	editor.grid_color2=GetColor(255,  0,  0);
	editor.char_color=GetColor(255,255,  0);
	editor.cursor_color=GetColor(255,  0,  0);
	editor.button_color=GetColor(128,128,128);
	editor.graph_chip_mode=1;

	for(int i=0;i<CHIP_NUM;i++){
		sprintf(fname,"data/img/chip/%d.png",i);
		editor.img_chip[i]=LoadGraph(fname);
	}
}

void editor_map_select(){
	if(CheckStateKey(KEY_INPUT_Q)==1 || (CheckStateKey(KEY_INPUT_Q)>30 && CheckStateKey(KEY_INPUT_Q)%5==1)){
		if(editor.map_num>0){
			editor.map_num--;
		}
	}
	if(CheckStateKey(KEY_INPUT_E)==1 || (CheckStateKey(KEY_INPUT_E)>30 && CheckStateKey(KEY_INPUT_E)%5==1)){
		editor.map_num++;
	}
}

//map_max_xύXꂽꍇ̓}bvȂ悤ɏC
void editor_map_size_control(){
	int i,j;
	//EVtgĂȂȂ\ʒüړ
	if(CheckStateKey(KEY_INPUT_RSHIFT)==0) return ;

	if(CheckStateKey(KEY_INPUT_D)==1 || (CheckStateKey(KEY_INPUT_D)>30 && CheckStateKey(KEY_INPUT_D)%5==1) ){
		if( (editor.map_max_x+1)*editor.map_max_y<=DATA_MAX){
			for(i=0;i<editor.map_max_x*editor.map_max_y;i++){
				editor.temp_data[i]=editor.data[i];
			}
			editor.map_max_x++;
			for(i=0;i<editor.map_max_y;i++){
				for(j=0;j<editor.map_max_x;j++){
					if(j==editor.map_max_x-1){
						editor.data[i*editor.map_max_x+j]=0;
					}
					else editor.data[i*editor.map_max_x+j]=editor.temp_data[i*(editor.map_max_x-1)+j];
				}
			}
		}
		
	}
	if(CheckStateKey(KEY_INPUT_A)==1 || (CheckStateKey(KEY_INPUT_A)>30 && CheckStateKey(KEY_INPUT_A)%5==1) ){
		if(editor.map_max_x>1){
			for(i=0;i<editor.map_max_x*editor.map_max_y;i++){
				editor.temp_data[i]=editor.data[i];
			}
			editor.map_max_x--;
			for(i=0;i<editor.map_max_y;i++){
				for(j=0;j<editor.map_max_x;j++){
					editor.data[i*editor.map_max_x+j]=editor.temp_data[i*(editor.map_max_x+1)+j];
				}
			}
		}
	}
	if(CheckStateKey(KEY_INPUT_S)==1 || (CheckStateKey(KEY_INPUT_S)>30 && CheckStateKey(KEY_INPUT_S)%5==1) ){
		if(editor.map_max_x*(editor.map_max_y+1)<=DATA_MAX){
			editor.map_max_y++;
			for(i=0;i<editor.map_max_x;i++){
				editor.data[(editor.map_max_y-1)*editor.map_max_x+i]=0;
			}
		}
	}
	if(CheckStateKey(KEY_INPUT_W)==1 || (CheckStateKey(KEY_INPUT_W)>30 && CheckStateKey(KEY_INPUT_W)%5==1) ){
		if(editor.map_max_y>1){
			editor.map_max_y--;
		}
	}
}

void editor_move(){
	//EVtgĂ}bvTCY̕ύX
	if(CheckStateKey(KEY_INPUT_RSHIFT)!=0) return;
	//\̈̈ړ
	if(CheckStateKey(KEY_INPUT_D)==1 || (CheckStateKey(KEY_INPUT_D)>30 && CheckStateKey(KEY_INPUT_D)%5==1) ){
		if(editor.field_x<editor.map_max_x-15){
			editor.field_x++;
		}
	}
	if(CheckStateKey(KEY_INPUT_A)==1 || (CheckStateKey(KEY_INPUT_A)>30 && CheckStateKey(KEY_INPUT_A)%5==1) ){
		if(editor.field_x>0){
			editor.field_x--;
		}
	}
	if(CheckStateKey(KEY_INPUT_S)==1 || (CheckStateKey(KEY_INPUT_S)>30 && CheckStateKey(KEY_INPUT_S)%5==1) ){
		if(editor.field_y<editor.map_max_y-15){
			editor.field_y++;
		}
	}
	if(CheckStateKey(KEY_INPUT_W)==1 || (CheckStateKey(KEY_INPUT_W)>30 && CheckStateKey(KEY_INPUT_W)%5==1) ){
		if(editor.field_y>0){
			editor.field_y--;
		}
	}
	//J[\ʒu̐
	if(mouse.x>=0 && mouse.x<480 && mouse.y>=0 && mouse.y<480){
		editor.cursor_x=mouse.x/32;
		editor.cursor_y=mouse.y/32;
	}
	//IĂꏊ̌vZ
	//Iłꏊ}bvOꍇ-1
	if( (editor.cursor_x>=editor.map_max_x) || (editor.cursor_y>=editor.map_max_y) ){
		editor.select_data_num=-1;
	}
	else{
		editor.select_data_num=(editor.field_x+editor.cursor_x)
							+(editor.field_y+editor.cursor_y)*editor.map_max_x;
	}
}

void editor_chip_select(){
	if(mouse.wheel>0){
		if(editor.select_chip_num<CHIP_NUM-1){
			editor.select_chip_num++;
		}
	}
	if(mouse.wheel<0){
		if(editor.select_chip_num>0){
			editor.select_chip_num--;
		}
	}
	if(CheckMousePointBox(0,0,480,480)==1){
		if(editor.select_data_num>=0){
			if(mouse.left>0){
				editor.data[editor.select_data_num]=editor.select_chip_num;
			}
			if(mouse.right>0){
				editor.data[editor.select_data_num]=0;
			}
		}
	}
}

void editor_save(){
	int i,j;
	int data;
	FILE *fp;
	char fname[32];
	if(CheckMousePointBox(500,160,600,192)==1 && mouse.left==1){
		sprintf(fname,"%d.txt",editor.map_num);
		fp=fopen(fname,"w");
		if(fp!=NULL){
			for(i=0;i<editor.map_max_y;i++){
				for(j=0;j<editor.map_max_x;j++){
					data=editor.data[i*editor.map_max_x+j];
					if(data<10){
						fprintf(fp,"%d",data);
					}
					else if(data<10+26){
						fprintf(fp,"%c",data-10+'A');
					}
					else{
						fprintf(fp,"%c",data-10-26+'a');
					}
				}
				fprintf(fp,"\n");
			}
			fclose(fp);
			sprintf(editor.message_text,"Z[u܂");
			editor.message_count=60;
		}
	}
}

void editor_load(){
	int i=0;
	int max_x=0,max_y=0;
	int inputc;
	int x_flag=0;//max_x̒l肵
	FILE *fp;
	char fname[32];
	if(CheckMousePointBox(500,208,600,240)==1 && mouse.left==1){
		sprintf(fname,"%d.txt",editor.map_num);
		fp=fopen(fname,"r");
		if(fp!=NULL){
			do{
				inputc=fgetc(fp);
				if(inputc>='0' && inputc<='9'){
					editor.data[i]=inputc-'0';
					i++;
				}
				if(inputc>='A' && inputc<='Z'){
					editor.data[i]=inputc-'A'+10;
					i++;
				}
				if(inputc>='a' && inputc<='z'){
					editor.data[i]=inputc-'a'+10+26;
					i++;
				}
				if(inputc=='\n'){
					if(x_flag==0){
						max_x=i;
						x_flag=1;
					}
					max_y++;
				}
			} while(inputc!=EOF);
			fclose(fp);
			editor.map_max_x=max_x;
			editor.map_max_y=max_y;
			sprintf(editor.message_text,"[h܂");
			editor.message_count=60;
		}
	}
}

void editor_main(){
	editor_map_select();
	editor_map_size_control();
	editor_move();
	editor_chip_select();
	editor_save();
	editor_load();
}

void editor_graph(){
	int data_num;
	int x,y;
	for(y=0;y<FIELD_MAX_Y;y++){
		for(x=0;x<FIELD_MAX_X;x++){
			if(editor.field_x+x>=editor.map_max_x || editor.field_y+y>=editor.map_max_y){
				DrawString(x*32,y*32,"out",editor.char_color);
				continue;
			}

			data_num=(editor.field_x+x)+(editor.field_y+y)*editor.map_max_x;
			if(editor.graph_chip_mode==0 || editor.img_chip[editor.data[data_num]]==-1){
				if(editor.data[data_num]<10){
					DrawFormatString(x*32,y*32,editor.char_color,"%d",editor.data[data_num]);
				}
				else if(editor.data[data_num]<10+26){
					DrawFormatString(x*32,y*32,editor.char_color,"%c",editor.data[data_num]-10+'A');
				}
				else{
					DrawFormatString(x*32,y*32,editor.char_color,"%c",editor.data[data_num]-10-26+'a');
				}
			}
			else DrawGraph(x*32,y*32,editor.img_chip[editor.data[data_num]],TRUE);
		}
	}

	for(x=0;x<=15;x++){
		if( (editor.field_x+x)%15==0){
			DrawLine(32*x,0,32*x,480,editor.grid_color2);
		}
		else{
			DrawLine(32*x,0,32*x,480,editor.grid_color);
		}
	}
	for(y=0;y<=15;y++){
		if( (editor.field_y+y)%15==0){
			DrawLine(0,32*y,480,32*y,editor.grid_color2);
		}
		else{
			DrawLine(0,32*y,480,32*y,editor.grid_color);
		}
	}
	DrawBox(32*editor.cursor_x,32*editor.cursor_y,32*(editor.cursor_x+1)+1,32*(editor.cursor_y+1)+1,editor.cursor_color,FALSE);

	DrawString(500,16,"Iłꏊ",editor.char_color);
	DrawFormatString(520,32,editor.char_color,"(%d,%d)",editor.field_x+editor.cursor_x,editor.field_y+editor.cursor_y);

	DrawString(500,64,"Iłԍ",editor.char_color);
	if(editor.select_chip_num<10){
		DrawFormatString(520,80,editor.char_color,"%d",editor.select_chip_num);
	}
	else if(editor.select_chip_num<10+26){
		DrawFormatString(520,80,editor.char_color,"%c",(editor.select_chip_num-10)+'A');
	}
	else if(editor.select_chip_num<10+26+26){
		DrawFormatString(520,80,editor.char_color,"%c",(editor.select_chip_num-(10+26))+'a');
	}
	if(editor.graph_chip_mode==1 && editor.img_chip[editor.select_chip_num]!=-1){
		DrawGraph(600,80,editor.img_chip[editor.select_chip_num],TRUE);
	} 

//	DrawString(500,112,"`bv\@",editor.char_color);
//	if(editor.graph_chip_mode==0){
//		DrawString(500,128,"̂",editor.char_color);
//	}
//	else{
//		DrawString(500,128,"Ɖ摜",editor.char_color);
//	}

	DrawBox(500,160,600,192,editor.button_color,TRUE);
	DrawString(520,168,"SAVE",editor.char_color);

	DrawBox(500,208,600,240,editor.button_color,TRUE);
	DrawString(520,216,"LOAD",editor.char_color);

	DrawFormatString(500,270,editor.char_color,"}bvԍ %d",editor.map_num);

	DrawString(500,286,"}bvTCY",editor.char_color);
	DrawFormatString(520,302,editor.char_color,"%d,%d",editor.map_max_x,editor.map_max_y);

	if(editor.message_count>0){
		DrawString(500,464,editor.message_text,editor.char_color);
		editor.message_count--;
	}
}
