#define GLOBAL_INSTANCE
#include "GV.h"
#include "editor.h"

int ProcessLoop(){
	if(ProcessMessage()!=0)return -1;
	if(ClearDrawScreen()!=0) return -1;
	GetHitKeyStateAll_2();
	GetHitPadStateAll();
	GetMouseState();
	return 0;
}

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nShowCmd){

	SetMainWindowText("}bvGfB^");
	SetWindowIconID(100);
	SetOutApplicationLogValidFlag(FALSE);
	//SetMouseDispFlag(TRUE);//J[\\
	ChangeWindowMode(TRUE);

	if(DxLib_Init() == -1 || SetDrawScreen( DX_SCREEN_BACK )!=0 ) return -1;

	first_ini();
	load();
	editor_ini();

	while(ProcessLoop()==0){
		editor_main();

		if(CheckStateKey(KEY_INPUT_ESCAPE)==1) break;
		graph_main();
		se_main();
		ScreenFlip();

		fps_wait();
	}
	DxLib_End();
	return 0;
}

